find_path(LIBXC_INCLUDE_DIR xc.h ${LIBXC_PATH} ${LIBXC_PATH}/include /opt/etsf/include NO_DEFAULT_PATH)
find_path(LIBXC_INCLUDE_DIR xc.h)
find_library(LIBXC_LIBRARY NAMES xc PATHS  ${LIBXC_PATH} ${LIBXC_PATH}/lib  ${LIBXC_PATH}/lib64 /opt/etsf/lib /opt/etsf/lib64 NO_DEFAULT_PATH)
find_library(LIBXC_LIBRARY NAMES xc)

if(LIBXC_INCLUDE_DIR AND LIBXC_LIBRARY)
	set(LIBXC_FOUND TRUE)
endif()


if(LIBXC_FOUND)
	if(NOT LIBXC_FIND_QUIETLY)
		message(STATUS "Found LibXC: ${LIBXC_LIBRARY}")
	endif()
else()
	if(LIBXC_FIND_REQUIRED)
		if(NOT LIBXC_INCLUDE_DIR)
			message(FATAL_ERROR "Could not find LibXC headers (Add -D LIBXC_PATH=<path> to the cmake commandline for a non-standard installation)")
		endif()
		if(NOT LIBXC_LIBRARY)
			message(FATAL_ERROR "Could not find LibXC shared libraries (Add -D LIBXC_PATH=<path> to the cmake commandline for a non-standard installation)")
		endif()
	endif()
endif()
